
registry:
  url: "{{ k8s_binderhub_oci_registry_host_full_url }}"
  username: "{{ k8s_binderhub_oci_registry_username }}"
  password: "{{ k8s_binderhub_oci_registry_password }}" 

pdb:
  enabled: true
  maxUnavailable: 1
  minAvailable:

replicas: 1

resources:
  requests:
    cpu: 0.2
    memory: 512Mi

rbac:
  enabled: true

imageCleaner:
  tolerations: {{ k8s_binderhub_imagecleaner_tolerations | to_json }}

image:
{% if k8s_binderhub_image_config.name %}
  name: "{{ k8s_binderhub_image_config.name }}"
{% endif %}
{% if k8s_binderhub_image_config.tag %}
  tag: "{{ k8s_binderhub_image_config.tag }}"
{% endif %}
  pullPolicy: "{{ k8s_binderhub_image_config.pullPolicy }}"

config:
  BinderHub:
    cors_allow_origin: '*'
    image_prefix: "{{ k8s_binderhub_oci_registry_host }}/binderhub/ska-jupy-"
{% if k8s_binderhub_singleuser %}
    auth_enabled: false
{% else %}
    auth_enabled: true
{% endif %}
    hub_url: "{{ k8s_binderhub_transport }}://{{ k8s_external_dns_entry }}/{{ k8s_binderhub_namespace }}/jupyterhub/"
    hub_url_local: "http://proxy-public/{{ k8s_binderhub_namespace }}/jupyterhub/"
    base_url: "/{{ k8s_binderhub_namespace }}/"
    build_node_selector: {}
    use_registry: {{ k8s_binderhub_use_registry | lower }}
  KubernetesBuildExecutor: {}
  DockerRegistry:
    token_url: "{{ k8s_binderhub_oci_registry_host_full_url }}/v2/token?service="

# https://binderhub.readthedocs.io/en/latest/https.html
service:
  type: ClusterIP

ingress:
  enabled: true
  https:
{% if k8s_binderhub_transport == 'http' %}
    enabled: false
{% else %}
    enabled: true
{% endif %}
  pathSuffix: "{{ k8s_binderhub_namespace }}"
  pathType: Prefix
  annotations:
    ingressClassName: "{{ k8s_binderhub_ingress_class }}"
{% if k8s_binderhub_force_ssl_redirect %}
    nginx.ingress.kubernetes.io/force-ssl-redirect: "true"
{% endif %}
    nginx.ingress.kubernetes.io/configuration-snippet: |
        rewrite ^/{{ k8s_binderhub_namespace }}$ /{{ k8s_binderhub_namespace }}/ permanent;
{% for key, value in k8s_binderhub_ingress_annotations.items() %}
    {{ key }}: {{ value }}
{% endfor %}

jupyterhub: #this is the redefined name of the chart root property of the jupyterhub chart TODO: maybe keep using the upstraem name and keep the chart name ska-jupyterhub
  scheduling:
    userScheduler:
      enabled: {{ k8s_binderhub_jupyterhub_scheduling_enabled }}
  proxy:
    service:
      type: ClusterIP
    secretSync:
      image:
{% if k8s_binderhub_jupyterhub_images_config.secret_sync.name %}
        name: "{{k8s_binderhub_jupyterhub_images_config.secret_sync.name }}"
{% endif %}
{% if k8s_binderhub_jupyterhub_images_config.secret_sync.tag %}
        tag: "{{ k8s_binderhub_jupyterhub_images_config.secret_sync.tag }}"
{% endif %}
        pullPolicy: "{{  k8s_binderhub_jupyterhub_images_config.secret_sync.pullPolicy }}"
  imagePullSecret:
    create: true
    automaticReferenceInjection: true
    registry: "{{ k8s_binderhub_oci_registry_host_full_url }}"
    username: "{{ k8s_binderhub_oci_registry_username }}"
    password: "{{ k8s_binderhub_oci_registry_password }}"
  custom:
    cors: {}
  cull:
    enabled: true
    users: true # cull authenticated users too
  hub:
    image:
{% if k8s_binderhub_jupyterhub_images_config.hub.name %}
      name: "{{k8s_binderhub_jupyterhub_images_config.hub.name }}"
{% endif %}
{% if k8s_binderhub_jupyterhub_images_config.hub.tag %}
      tag: "{{ k8s_binderhub_jupyterhub_images_config.hub.tag }}"
{% endif %}
      pullPolicy: "{{  k8s_binderhub_jupyterhub_images_config.hub.pullPolicy }}"
    redirectToServer: false
    baseUrl: "/{{ k8s_binderhub_namespace }}/jupyterhub"
    services:
      binder: {}
{% if k8s_binderhub_singleuser %}
    allowNamedServers: false
{% else %}
    allowNamedServers: true
{% endif %}
    namedServerLimitPerUser: {{ k8s_binderhub_jupyterhub_named_server_limit_per_user }}
    db:
      pvc:
        storageClassName: nfss1
    config:
{% if k8s_binderhub_singleuser %}
      JupyterHub:
        authenticator_class: jupyterhub.auth.DummyAuthenticator
      BinderSpawner:
        auth_enabled: false
        cors_allow_origin: "*"
        k8s_api_request_timeout: {{ k8s_binderhub_spawn_timeout }}
{% elif k8s_binderhub_azuread_enabled %}
      BinderSpawner:
        auth_enabled: true
        cors_allow_origin: "*"
        k8s_api_request_timeout: {{ k8s_binderhub_spawn_timeout }}
      JupyterHub:
        authenticator_class: azuread
      AzureAdOAuthenticator:
        client_id: "{{ k8s_binderhub_azuread_client_id }}"
        client_secret: "{{ k8s_binderhub_azuread_client_secret }}"
        oauth_callback_url: "{{ k8s_binderhub_jupyterhub_callback_url }}"
        tenant_id: "{{ k8s_binderhub_azuread_tenant_id }}"
        allow_all: true
    services:
      binder:
        oauth_redirect_uri: "{{ k8s_binderhub_callback_url }}"
        oauth_client_id: service-binderhub
{% else %}
      BinderSpawner:
        auth_enabled: true
        cors_allow_origin: "*"
        k8s_api_request_timeout: {{ k8s_binderhub_spawn_timeout }}
      JupyterHub:
        authenticator_class: gitlab
      GitLabOAuthenticator:
        allowed_gitlab_groups: {{ k8s_binderhub_gitlab_allowed_groups }}
        client_id: "{{ k8s_binderhub_gitlab_client_id }}"
        client_secret: "{{ k8s_binderhub_gitlab_client_secret }}"
        oauth_callback_url: "{{ k8s_binderhub_jupyterhub_callback_url }}"
        create_system_users: true
        allow_all: true
    services:
      binder:
        oauth_redirect_uri: "{{ k8s_binderhub_callback_url }}"
        oauth_client_id: service-binderhub
{% endif %}
    loadRoles:
      user:
        scopes:
          - self
          - "access:services"
{% if k8s_binderhub_singleuser %}
          - "access:servers"

    extraConfig:
      binder: |
        from kubespawner import KubeSpawner

        class BinderSpawner(KubeSpawner):
          def start(self):
            if 'image' in self.user_options:
              # binder service sets the image spec via user options
              self.image = self.user_options['image']
            return super().start()
        c.JupyterHub.spawner_class = BinderSpawner
{% endif %}

{% if k8s_binderhub_azuread_auth_roles %}
    extraConfig:
      post_auth_hook: |
        from tornado import web

        def custom_post_auth_hook(authenticator, handler, authentication):
            auth_state = authentication['auth_state']
            user_info = authentication['auth_state']['user']
            roles = user_info.get('roles', [])
            allowed_roles = {{ k8s_binderhub_azuread_auth_roles | tojson }}
            if not any(role in allowed_roles for role in roles):
              raise web.HTTPError(403, "You do not have access to this BinderHub")
            return authentication

        c.AzureAdOAuthenticator.post_auth_hook = custom_post_auth_hook
{% endif %}

    resources:
      requests:
        cpu: "{{ k8s_binderhub_jupyterhub_resources_config.cpu.requests }}"
        memory: "{{ k8s_binderhub_jupyterhub_resources_config.memory.requests }}"
        ephemeral-storage: "{{ k8s_binderhub_jupyterhub_resources_config.ephemeral_storage.requests }}"
      limits:
        cpu: "{{ k8s_binderhub_jupyterhub_resources_config.cpu.limits }}"
        memory: "{{ k8s_binderhub_jupyterhub_resources_config.memory.limits }}"
        ephemeral-storage: "{{ k8s_binderhub_jupyterhub_resources_config.ephemeral_storage.limits }}"
  singleuser:
    # start jupyterlab server *if available*
    # fallback on jupyter-notebook
    cmd: jupyterhub-singleuser
    memory:
      limit: "{{ k8s_binderhub_singleuser_resources_config.memory.limit }}"
      guarantee: "{{ k8s_binderhub_singleuser_resources_config.memory.guarantee }}"
    cpu:
      limit: {{ k8s_binderhub_singleuser_resources_config.cpu.limit }}
      guarantee: {{ k8s_binderhub_singleuser_resources_config.cpu.guarantee }}
    storage:
      type: dynamic
{% if k8s_binderhub_singleuser_resources_config.storage.type == 'dynamic' %}
      dynamic:
        storageClass: "{{ k8s_binderhub_singleuser_resources_config.storage.dynamic.storageClass }}"
        pvcNameTemplate: claim-{userid}-{servername}
        volumeNameTemplate: vol-{userid}-{servername}
{% endif %}
      capacity: "{{ k8s_binderhub_singleuser_resources_config.storage.capacity }}"
      homeMountPath: "{{ k8s_binderhub_singleuser_resources_config.storage.homeMountPath }}"
{% if k8s_binderhub_jupyterhub_volumes | length > 0 %}
      extraVolumes: {{ jupyterhub_extra_volumes }}
      extraVolumeMounts: {{ jupyterhub_extra_volume_mounts }}
{% endif %}
{% if k8s_binderhub_jupyterhub_profiles | length > 0 %}
    profileList: {{ k8s_binderhub_jupyterhub_profiles }}
{% endif %}
    networkTools:
      image:
{% if k8s_binderhub_jupyterhub_images_config.network_tools.name %}
        name: "{{k8s_binderhub_jupyterhub_images_config.network_tools.name }}"
{% endif %}
{% if k8s_binderhub_jupyterhub_images_config.network_tools.tag %}
        tag: "{{ k8s_binderhub_jupyterhub_images_config.network_tools.tag }}"
{% endif %}
        pullPolicy: "{{  k8s_binderhub_jupyterhub_images_config.network_tools.pullPolicy }}"
    image:
{% if k8s_binderhub_jupyterhub_images_config.singleuser.name %}
      name: "{{k8s_binderhub_jupyterhub_images_config.singleuser.name }}"
{% endif %}
{% if k8s_binderhub_jupyterhub_images_config.singleuser.tag %}
      tag: "{{ k8s_binderhub_jupyterhub_images_config.singleuser.tag }}"
{% endif %}
      pullPolicy: "{{  k8s_binderhub_jupyterhub_images_config.singleuser.pullPolicy }}"

  # Explicitly enable egress traffic to Kubernetes services of type ClusterIP
  # required to make it possible to talk to Tango
    networkPolicy:
      egressAllowRules:
        privateIPs: true

  ingress:
    enabled: true
    pathType: Prefix
    annotations:
      ingressClassName: "{{ k8s_binderhub_jupyterhub_ingress_class }}"
{% if k8s_binderhub_force_ssl_redirect %}
      nginx.ingress.kubernetes.io/force-ssl-redirect: "true"
{% endif %}
{% for key, value in k8s_binderhub_jupyterhub_ingress_annotations.items() %}
      {{ key }}: {{ value }}
{% endfor %}

  prePuller:
    hook:
      image:
{% if k8s_binderhub_jupyterhub_images_config.image_waiter.name %}
        name: "{{k8s_binderhub_jupyterhub_images_config.image_waiter.name }}"
{% endif %}
{% if k8s_binderhub_jupyterhub_images_config.image_waiter.tag %}
        tag: "{{ k8s_binderhub_jupyterhub_images_config.image_waiter.tag }}"
{% endif %}
        pullPolicy: "{{  k8s_binderhub_jupyterhub_images_config.image_waiter.pullPolicy }}"
